#! /usr/bin/perl
#
#  Purpose:
#  FlowTracker_DisplayPublic.cgi displays a selected FlowTracking.
#
#  Description:
#
#  FlowTracker_DisplayPublic.cgi is invoked to display the selected tracking
#  in the Public display window.
#
#  Input arguments:
#  Name                 Description
#  -----------------------------------------------------------------------
#  filter_hash          Name of the Tracking to be displayed
#
#  Modification history:
#  Author       Date            Vers.   Description
#  -----------------------------------------------------------------------
#  J. Loiacono  05/08/2012      4.0     Original Version.
#
#$Author$
#$Date$
#$Header$
#
###########################################################################
#
#               BEGIN EXECUTABLE STATEMENTS
#
 
use FlowViewer_Configuration;
use FlowViewer_Utilities;
use FlowViewer_UI;

if ($debug_tracker eq "Y") { open (DEBUG,">$work_directory/DEBUG_TRACKER"); }
if ($debug_tracker eq "Y") { print DEBUG "In FlowTracker_DisplayPublic.cgi\n"; }

$query_string = $ENV{'QUERY_STRING'};
$query_string =~ s/%([0-9A-Fa-f]{2})/chr(hex($1))/ge ;
($label,$filter_hash) = split(/=/,$query_string);
if ($debug_tracker eq "Y") { print DEBUG "FlowTracker_DisplayPublic: filter_hash: $filter_hash\n"; }

print "Content-type:text/html\n\n";
print "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01//EN\"\n";
print "\"http://www.w3.org/TR/html4/strict.dtd\">\n\n";
print "<html lang=en>\n";
print "<head>\n";
print "<meta http-equiv=Content-Type content=\"text/html; charset=utf-8\">\n";
print "<title>FlowViewer - Maintaining Network Traffic Situational Awareness</title>\n";
print "<link rel=\"stylesheet\" href=\"$reports_short/FlowViewer.css\" type=\"text/css\">\n";
print "</head>\n";
print "<body>\n";
print "<center>\n";
print "<br>\n";
print "\n";

print "<div id=container>\n";
print " <div id=title_left>\n";
print "  <a href=$tracker_short/index.html><span class=link16>$left_title</span></a>\n";
print " </div>\n";
print " <div id=title_right>\n";
print "  <a href=$tracker_short/index.html><span class=link16>$right_title</span></a>\n";
print " </div>\n";
print " <div id=title_center>\n";
print "  <a href=$tracker_short/index.html><span class=text20>FlowViewer</span></a>\n";
print "  <p>\n";
print "  <a href=$tracker_short/index.html><span class=text12>Powered by flow-tools and SiLK</span></a>\n";
print " </div>\n";
print "\n";

print " <div class=gradient_down id=service_top></div>\n";
print " <div id=content_wide>\n";

&create_filter_output("FlowTracker",$filter_hash);

($tracking_file,$suffix) = split(/\./,$filter_filename);

print " <center>\n";
print " <br><br><img src=$tracker_short/$tracking_file/daily.png usemap=#TrackerGraph_Map_1>\n";
print " <br><br><br><hr><br><br><img src=$tracker_short/$tracking_file/weekly.png usemap=#TrackerGraph_Map_2>\n";
print " <br><br><br><hr><br><br><img src=$tracker_short/$tracking_file/monthly.png usemap=#TrackerGraph_Map_3>\n";
print " <br><br><br><hr><br><br><img src=$tracker_short/$tracking_file/yearly.png usemap=#TrackerGraph_Map_4>\n";
print " <br><br><br><hr><br><br><img src=$tracker_short/$tracking_file/threeyears.png usemap=#TrackerGraph_Map_5>\n";
print " </center>\n";

if ($suffix eq "archive") {
        $archive_file = "$filter_directory/$filter_filename";
        open (FILTER,"<$archive_file");
        while (<FILTER>) {
                chop;
                $key = substr($_,0,28);
                if ($key eq " input: tracking_type: Group") {
                        $is_group = 1;
                        last;
                } else {
                        next;
                }
        }
}

if ($suffix eq "grp") { $is_group = 1; }

if ($is_group) {

	$group_file = "$filter_directory/$filter_filename";
        open (FILTER,"<$group_file");
        while (<FILTER>) {
                chop;
                $key = substr($_,0,8);
                if ($key eq " input: ") {
                        next;
                } else {
                        ($component_position,$component_label,$component_color) = split(/\^/);
                        $component_file = $component_label;
                        $component_file =~ s/^\s+//;
                        $component_file =~ s/\s+$//;
                        $component_file =~ s/\&/-/g;
                        $component_file =~ s/\//-/g;
                        $component_file =~ s/\(/-/g;
                        $component_file =~ s/\)/-/g;
                        $component_file =~ s/\./-/g;
                        $component_file =~ s/\s+/_/g;
                        $component_file =~ tr/[A-Z]/[a-z]/;
                        $component_html  = "$cgi_bin_short/FlowTracker_DisplayPublic.cgi?filter_hash=TR_$component_file.fil";

                        $component_archive  = $rrdtool_directory ."/". $component_file .".archive";
                        if (-e $component_archive) { $component_html = "$cgi_bin_short/FlowTracker_DisplayPublic.cgi?filter_hash=TR_$component_file.archive"; }

                        push (@component_links,$component_html);
                }
        }

        for ($k=1;$k<=5;$k++) {
                print "   <map name=TrackerGraph_Map_$k>\n";
                $num_link = 0;
                foreach $component_link (@component_links) {
                        $num_link++;
                        $x1 = 75;
                        $y1 = 217 + ($num_link * 14);
                        $x2 = 350;
                        $y2 = $y1 + 14;
                        print " <area shape=rect coords=\"$x1,$y1,$x2,$y2\" href=$component_link>\n";
                }
                print " </map>\n";
        }

} else {

	print "   <map name=TrackerGraph_Map_1>\n";
	print "   <area shape=rect coords=450,270,570,290 href=$cgi_bin_short/FlowTracker_Dumper.cgi?24_hours^$tracking_file^>\n";
	print "   </map>\n";
	print "   <map name=TrackerGraph_Map_2>\n";
	print "   <area shape=rect coords=450,270,570,290 href=$cgi_bin_short/FlowTracker_Dumper.cgi?7_days^$tracking_file^>\n";
	print "   </map>\n";
	print "   <map name=TrackerGraph_Map_3>\n";
	print "   <area shape=rect coords=450,270,570,290 href=$cgi_bin_short/FlowTracker_Dumper.cgi?4_weeks^$tracking_file^>\n";
	print "   </map>\n";
	print "   <map name=TrackerGraph_Map_4>\n";
	print "   <area shape=rect coords=450,270,570,290 href=$cgi_bin_short/FlowTracker_Dumper.cgi?12_months^$tracking_file^>\n";
	print "   </map>\n";
	print "   <map name=TrackerGraph_Map_5>\n";
	print "   <area shape=rect coords=450,270,570,290 href=$cgi_bin_short/FlowTracker_Dumper.cgi?3_years^$tracking_file^>\n";
	print "   </map>\n";
}

print " </div>\n";
print " <div class=gradient_down id=service_bottom>\n";
print " <a href=$tracker_short/index.html><span class=link16>Return to List of Trackings</span></a>\n";
print "</div>\n";
print "</div>\n";
print "</body>\n";
print "</html>\n";
