#! /usr/bin/perl
#
#  Purpose:
#  FlowTracker_Replay.cgi displays a saved FlowTracking
#
#  Description:
#
#  FlowTracker_Replay.cgi is invoked to display the selected saved
#  FlowTracking in the display window.
#
#  Input arguments:
#  Name                 Description
#  -----------------------------------------------------------------------
#  filter_hash          Name of the Tracking to be displayed
#
#  Modification history:
#  Author       Date            Vers.   Description
#  -----------------------------------------------------------------------
#  J. Loiacono  05/08/2012      4.0     Original Version.
#
#$Author$
#$Date$
#$Header$
#
###########################################################################
#
#               BEGIN EXECUTABLE STATEMENTS
#
 
use FlowViewer_Configuration;
use FlowViewer_Utilities;
use FlowViewer_UI;

if ($debug_tracker eq "Y") { open (DEBUG,">$work_directory/DEBUG_TRACKER"); }
if ($debug_tracker eq "Y") { print DEBUG "In FlowTracker_Replay.cgi\n"; }

$query_string  = $ENV{'QUERY_STRING'};
$query_string  =~ s/%([0-9A-Fa-f]{2})/chr(hex($1))/ge ;
($label,$filter_hash) = split(/=/,$query_string);
$filter_source = substr($filter_hash,0,2);

&create_UI_top("FlowTracker");
&create_UI_service("FlowTracker","service_top",$filter_hash);

# Create the FlowTracking Replay Content

print " <div id=content_wide>\n";
&create_filter_output("FlowTracker_Replay",$filter_hash);

($tracking_file,$suffix) = split(/\./,$filter_filename);
$TR_saved_directory = $save_short ."/". substr($tracking_file,0,25);

if ($debug_tracker eq "Y") { print DEBUG "FlowTracker_Replay: filter_hash: $filter_hash  filter_filename: $filter_filename\n"; }

print " <center>\n";
print " <br><br><img src=$TR_saved_directory/daily.png>\n";
print " <br><br><br><hr><br><br><img src=$TR_saved_directory/weekly.png>\n";
print " <br><br><br><hr><br><br><img src=$TR_saved_directory/monthly.png>\n";
print " <br><br><br><hr><br><br><img src=$TR_saved_directory/yearly.png>\n";
print " <br><br><br><hr><br><br><img src=$TR_saved_directory/threeyears.png>\n";
print " </center>\n";

if ($suffix eq "archive") {
	$archive_file = "$filter_directory/$filter_filename";
        open (FILTER,"<$archive_file");
        while (<FILTER>) {
                chop;
                $key = substr($_,0,28);
                if ($key eq " input: tracking_type: Group") {
                        $is_group = 1;
			last;
                } else {
			next;
		}
	}
}

if ($suffix eq "grp") { $is_group = 1; }

if ($is_group) {

	$group_file = "$filter_directory/$filter_filename";
        open (FILTER,"<$group_file");
        while (<FILTER>) {
                chop;
                $key = substr($_,0,8);
                if ($key eq " input: ") {
                        next;
                } else {
                        ($component_position,$component_label,$component_color) = split(/\^/);
                        $component_file = $component_label;
                        $component_file =~ s/^\s+//;
                        $component_file =~ s/\s+$//;
                        $component_file =~ s/\&/-/g;
                        $component_file =~ s/\//-/g;
                        $component_file =~ s/\(/-/g;
                        $component_file =~ s/\)/-/g;
                        $component_file =~ s/\./-/g;
                        $component_file =~ s/\s+/_/g;
                        $component_file =~ tr/[A-Z]/[a-z]/;
                        $component_html  = "$cgi_bin_short/FlowTracker_Display.cgi?filter_hash=TR_$component_file.fil";

                        $component_archive  = $rrdtool_directory ."/". $component_file .".archive";
                        if (-e $component_archive) { $component_html = "$cgi_bin_short/FlowTracker_Display.cgi?filter_hash=TR_$component_file.archive"; }

                        push (@component_links,$component_html);
                }
        }

        for ($k=1;$k<=5;$k++) {
                print "   <map name=TrackerGraph_Map_$k>\n";
                $num_link = 0;
                foreach $component_link (@component_links) {
                        $num_link++;
                        $x1 = 75;
                        $y1 = 217 + ($num_link * 14);
                        $x2 = 350;
                        $y2 = $y1 + 14;
                        print " <area shape=rect coords=\"$x1,$y1,$x2,$y2\" href=$component_link>\n";
                }
                print " </map>\n";
        }
}

print " </div>\n";

&create_UI_service("FlowTracker","service_bottom",$filter_hash);
&finish_the_page("FlowTracker");
